/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	CircleSaw class


*******************************************************************************
******************************************************************************/

#include "CircleSaw.h"

#define MIN_X ( -32 << 12 )
#define MIN_Y ( -18 << 12 )

#define CIRCLE_SAW_MAX_HP (364 * 4)
//------------------------------------------------------------------------------
//	CircleSaw Enemy
//------------------------------------------------------------------------------
CircleSaw::CircleSaw()
{
	x = 600 <<12;
	y = 96 << 12;
	Frame = 0;
	Active = false;	
	Alive = true;
	DestroyedCounter = 60 * 5;
	Hp = 38 * 4; 
	
	Rotation = 0;;
	Delta = 32;
	Radius = 50;
	
	DrawMode = EN_NORMAL;
}

CircleSaw::~CircleSaw()
{
}


void CircleSaw::Init( int Palette, glImage* const Sprites )
{
	ColorTable = Palette;		// init needed data for drawing
	Images = Sprites;
}

void CircleSaw::Update()
{
	if( Active )
	{
		Rotation += Delta;
	
		Radius = 50 + ( ( sinLerp(Rotation*4) * 10 ) >> 12 );
		Path.Update();
		
		if( Path.GetIndex() == 5 ) ClosePath();
		
		x = Path.GetX();
		y = Path.GetY();
		
		Counter++;
		// animate
		Frame = 0;
	}
	
	if( Active ) Targets::Instance()->AddCoord( x, y );
	
}


void CircleSaw::LoadPath( int _sx, int _sy, int _ex, int _ey )
{
	Path.Init( 16 );
	
	Spline::Coord p;
	
	// start
	p.x = _sx;
	p.y = _sy;
	
	// we should use 2 points
	Path.AddPoint( p );
	Path.AddPoint( p );
	
	// randomize for now
	for (int i=0; i < 10; i++)
	{
		p.x = qran_range(0, 255);
		p.y = qran_range(0, 193);
		Path.AddPoint( p );
	}
	
	// close last 2 coords
	p.x = _ex;
	p.y = _ey;
	
	// we should use 2 points
	Path.AddPoint( p );
	Path.AddPoint( p );
	
	Path.SetSpeed(qran_range(16,32));
	Path.SetT(0);
	
}


void CircleSaw::Draw()
{
	static s32 rdelta = 0;
		
	glColor( RGB15(31,31,31) );
	if( Active )
	{
		if( (DrawMode == EN_WHITE) )
		{
			for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
			{
				int cx = x + Radius * cosLerp(i+Rotation);
				int cy = y + Radius * sinLerp(i+Rotation);
			
				rdelta += 32;
				DrawMode = EN_NORMAL;
				glColor( RGB15(31,0,0) );
				glSpriteRotate( (cx >> 12), (cy >> 12), i+Rotation+rdelta, 
						  GL_FLIP_NONE, &Images[Frame] 
						);
				glColor( RGB15(31,31,31) );
			}

		}
		else
		{
			for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
			{
				int cx = x + Radius * cosLerp(i+Rotation);
				int cy = y + Radius * sinLerp(i+Rotation);
				rdelta += 32;
				
				glSpriteRotate( (cx >> 12), (cy >> 12), i+Rotation+rdelta, 
						  GL_FLIP_NONE, &Images[Frame] 
						);
				
			}
		}
	
	}


	// draw energy
	int xx = (x >> 12) - 32;
	int yy = (y >> 12) - 4;
	
	int Length = 64;
	s32 Gauge = (Hp << 12) / CIRCLE_SAW_MAX_HP;
	int GaugeLength = ( UTIL::Lerpf32( 0, Length << 12, Gauge ) );
	glBoxFilledGradient( xx, yy,
						xx + (GaugeLength >> 12), 
						yy+ 4,
						RGB15(31,0,0),
						RGB15(31,0,0),
						RGB15(0,31,0),
						RGB15(0,0,31) );
	
	glBox(xx, yy, xx + (Length), yy + 4, RGB15(Counter, Counter/2, 31-Counter) );
	
}


bool CircleSaw::Collide( StarFighter &Star )
{
	
	if( Active )
	{
		int rad2 = 16 * 16;
		for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
		{
			s32 rx = x + Radius * cosLerp(i+Rotation);
			s32 ry = y + Radius * sinLerp(i+Rotation);
			
			
			// veiw collision 
			//int gx = rx >> 12;
			//int gy = ry >> 12;
			//glBoxFilled( gx-8, gy-8, gx+8, gy+8, RGB15(31,31,31) );
			
			int cx = (rx >> 12) - (Star.x >> 12);
			int cy = (ry >> 12) - (Star.y >> 12);
			if( ( (cx * cx) + (cy * cy) ) < (rad2 * (1+Star.IsBursting())) )
			{
				if( Star.IsBursting() )
				{
					Vector2df32 p;
					p.x = Star.x;
					p.y = Star.y;
					Particle::Instance()->Spawn( p, 2 );
					Star.IncreaseGauge(10);
					Hp -= 4;
					if( (Counter & 3) == 0 ) Sound::Instance()->PlaySFX(E_SFX_HIT);
					if( Hp < 0 )
					{
						Active = false;
						Alive = false;
						Star.Score += 15130;
						Sound::Instance()->PlaySFX(E_SFX_BIGEXP);
						// Add some nice explosions
						for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
						{	
							s32 dx = cosLerp(i+Rotation);
							s32 dy = sinLerp(i+Rotation);
							
							s32 rx = x + Radius * dx;
							s32 ry = y + Radius * dy;
			
							Explosion::Instance()->Spawn( rx >> 12,
													  ry >> 12,
													   dx,
													   dy,
													   Explode::MEDIUM_1
													 );
							
							
						}
						
						Explosion::Instance()->MegaSpawn(x >> 12,y >> 12,80,Explode::TINY,Explode::MEDIUM_5, 60*4 );
	
						x = 600 << 12;
						y = 96 << 12;
		
					}
					if( DrawMode == EN_NORMAL )
					{
						if( (Counter & 1) ) 
							DrawMode = EN_WHITE;
					}
				}
				else  // if not bursting
				{
					// kill star
					if( !Star.IsInvincible() ) Star.Kill();
				}
				return true;
			}
		
		}	// next i
		
		
	} // active
	
	
	// Missiles
	if( Active )
	{
		int rad2 = 16 * 16;
		for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
		{
			s32 rx = x + Radius * cosLerp(i+Rotation);
			s32 ry = y + Radius * sinLerp(i+Rotation);
			
			if( rx < ( 256 << 12 ) )
			{
				
				for( int z = 0; z < MAX_MISSILES; z++)
				{
					HomingMissile Missile= Star.GetMissile(z);
					
					if( Missile.IsActive() )
					{
						
						int cx = (rx >> 12) - (Missile.GetX() >> 12);
						int cy = (ry >> 12) - (Missile.GetY() >> 12);
						if( ( (cx * cx) + (cy * cy) ) < (rad2) )
						{
							
							Vector2df32 p;
							p.x = Missile.GetX();
							p.y = Missile.GetY();
							Particle::Instance()->Spawn( p, 1 );
							if( (Counter & 1) ) DrawMode = EN_WHITE;
							Star.DestroyMissile(z);
							
							Hp -= 1;
							if( (Counter & 3) == 0 ) Sound::Instance()->PlaySFX(E_SFX_HIT);
							
							if( Hp < 0 )
							{
								Active = false;
								Alive = false;
								Star.Score += 15130;
								Sound::Instance()->PlaySFX(E_SFX_BIGEXP);
								// Add some nice explosions
								for( int i = 0; i < (BRAD_PI*2); i += BRAD_PI/6 )
								{	
									s32 dx = cosLerp(i+Rotation);
									s32 dy = sinLerp(i+Rotation);
									
									s32 rx = x + Radius * dx;
									s32 ry = y + Radius * dy;
					
									Explosion::Instance()->Spawn( rx >> 12,
															  ry >> 12,
															   dx,
															   dy,
															   Explode::MEDIUM_1
															 );
									
									
								}
								
								Explosion::Instance()->MegaSpawn(x >> 12,y >> 12,80,Explode::TINY,Explode::MEDIUM_5, 60*4 );
			
								x = 600 << 12;
								y = 96 << 12;
				
							}
							
						}
						
					}   // missile active
			
				}  // next z
			}  //rx
		
		}	// next i
		
		
	} // active
	
	
	return false;
}



void CircleSaw::Spawn()
{
	
	Active = true;
	Alive = true;	
	DestroyedCounter = 60 * 5;
	Frame = 0;
	Counter = 0;
	Hp = 364 * 4;
	Rotation = 0;;
	Delta = 64;
	Radius = 50;
	LoadPath( 300, 96, -300, 96 );

	
}

void CircleSaw::ClosePath()
{
		
	Path.SetPoint( 0, qran_range(0, 255), qran_range(0, 193) );
	Path.SetPoint( 1, qran_range(0, 255), qran_range(0, 193) );
	
	Path.SetPoint( Path.GetMaxPoints() - 1, qran_range(0, 255), qran_range(0, 193) );
	Path.SetPoint( Path.GetMaxPoints() - 2, qran_range(0, 255), qran_range(0, 193) );
	
}