/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Skullo class


*******************************************************************************
******************************************************************************/

#include "Skullo.h"

#define MIN_X ( -20 << 12 )
#define MIN_Y ( -18 << 12 )

#define MAX_SKULLOS 16

//------------------------------------------------------------------------------
//	Skullo Enemy
//------------------------------------------------------------------------------
Skullo::Skullo()
{
	Frame = 0;
	Active = false;	
	Hp = 32; 
	DrawMode = EN_NORMAL;
	
}

Skullo::~Skullo()
{
}


void Skullo::Update()
{
	
	Path.Update();
	
	x = Path.GetX();
	y = Path.GetY();
	
	if( x < MIN_X )
	{
		Active = false;
		x = 300 << 12;
		y = 96 << 12;
	}

	Counter++;
	// animate
	if( ( Counter & 3 ) == 0 )
	{
		Frame = (Frame + 1) & 1;
	}
	
	if( Active ) Targets::Instance()->AddCoord( x, y );

}


void Skullo::LoadPath( int _sx, int _sy, int _ex, int _ey, s32 _time, bool _flip )
{
	Path.Init( 16 );
	
	Spline::Coord p;
	
	// start
	p.x = _sx;
	p.y = _sy;
	
	// we should use 2 points
	Path.AddPoint( p );
	Path.AddPoint( p );
	
	p.x = 270;
	p.y = 96;
	Path.AddPoint( p );
	
	p.x = 200;
	p.y = 20;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 255;
	p.y = 120;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 100;
	p.y = 80;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 200;
	p.y = 190;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 30;
	p.y = 120;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 200;
	p.y = 20;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 155;
	p.y = 120;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	p.x = 20;
	p.y = 180;
	if( _flip ) p.y = 196 - p.y;
	Path.AddPoint( p );
	
	// close last 2 coords
	p.x = _ex;
	p.y = _ey;
	
	// we should use 2 points
	Path.AddPoint( p );
	Path.AddPoint( p );
	
	Path.SetSpeed(32);
	Path.SetT(_time);
	
}
	
//------------------------------------------------------------------------------
//	Skullo Container
//------------------------------------------------------------------------------
//--------------------------------------
//	Ctor and Dtor
//--------------------------------------
SkulloContainer::SkulloContainer()
{
}
	
SkulloContainer::~SkulloContainer()
{
	Skullos.clear();				// clear the bullets
}


void SkulloContainer::Init( int Palette, glImage* const Sprites )
{
	ColorTable = Palette;		// init needed data for drawing
	Images = Sprites;
	Skullos.resize( MAX_SKULLOS/2 );			// 1/2 of max (speed of iteration)
	Skullos.reserve( MAX_SKULLOS );		// reserve max for speed.  No need to do this for enemies
}

//--------------------------------------
//	Virtual Functions
//--------------------------------------
void SkulloContainer::UpdateEntities()
{
	
	std::vector<Skullo>::iterator iter;
	for( iter = Skullos.begin(); iter != Skullos.end(); ++iter )
	{
		if( iter->Active )
			iter->Update();
	}
	
}

void SkulloContainer::DrawEntities()
{
	
	glColor( RGB15(31,31,31) );
	numEntities = 0;
	std::vector<Skullo>::iterator iter;
	for( iter = Skullos.begin(); iter != Skullos.end(); ++iter )
	{
		if( iter->Active )
		{
			numEntities++;
			if( (iter->DrawMode == EN_WHITE) )
			{
				iter->DrawMode = EN_NORMAL;
				glColor( RGB15(31,0,0) );
				glSprite( (iter->x >> 12) - 8, (iter->y >> 12) - 8, 
					      GL_FLIP_NONE, &Images[iter->Frame+50] 
					    );
				glColor( RGB15(31,31,31) );
	
			}
			else
			{
				glSprite( (iter->x >> 12) - 8, (iter->y >> 12) - 8, 
						  GL_FLIP_NONE, &Images[iter->Frame+50] 
					    );
			}
			
		}
	}
	
}

bool SkulloContainer::Collide( StarFighter &Star )
{
	std::vector<Skullo>::iterator iter;
	for( iter = Skullos.begin(); iter != Skullos.end(); ++iter )
	{
		if( iter->Active )
		{
			int rad2 = 8 * 8;
			int cx = (iter->x >> 12) - (Star.x >> 12);
			int cy = (iter->y >> 12) - (Star.y >> 12);
			if( ( (cx * cx) + (cy * cy) ) < (rad2 * (1+Star.IsBursting())) )
			{
				if( Star.IsBursting() )
				{
					Vector2df32 p;
					p.x = Star.x;
					p.y = Star.y;
					Particle::Instance()->Spawn( p, 2 );
					Star.IncreaseGauge(15);
					iter->Hp--;
					if( (iter->Hp & 3) == 0 ) Sound::Instance()->PlaySFX(E_SFX_HIT);
					if( iter->Hp < 0 )
					{
						iter->Active = false;
						Star.Score += 30;
						Sound::Instance()->PlaySFX(E_SFX_SMALLEXP);
						// Add some nice explosions
						Explosion::Instance()->Spawn( iter->x >> 12,
													  iter->y >> 12,
													   0,
													   0,
													   Explode::SMALL_3
													 );
							
						iter->x = 600 <<12;
						iter->y = 96 << 12;
						
					}
					if( iter->DrawMode == EN_NORMAL )
					{
						if( (iter->Counter & 1) ) iter->DrawMode = EN_WHITE;
					}
				}
				else
				{
					// kill star
					if( !Star.IsInvincible() ) Star.Kill();
				}
				return true;
			}
		}
		
		// missiles if after star enemy is still active
		if( iter->Active )
		{
			int rad2 = 8 * 8;
			
			if( iter->x < ( 256 << 12 ) )
			{
			
				// Missiles
				for( int i = 0; i < MAX_MISSILES; i++)
				{
					HomingMissile Missile= Star.GetMissile(i);
					
					if( Missile.IsActive() )
					{
						int cx = (iter->x >> 12) - (Missile.GetX() >> 12);
						int cy = (iter->y >> 12) - (Missile.GetY() >> 12);
						if( ( (cx * cx) + (cy * cy) ) < (rad2) )
						{
							Vector2df32 p;
							p.x = Missile.GetX();
							p.y = Missile.GetY();
							Particle::Instance()->Spawn( p, 1 );
							Star.DestroyMissile(i);
							iter->Hp--;
							if( iter->Hp < 0 )
							{
								iter->Active = false;
								Star.Score += 33;
								Sound::Instance()->PlaySFX(E_SFX_SMALLEXP);
								// Add some nice explosions
								Explosion::Instance()->Spawn( iter->x >> 12,
															  iter->y >> 12,
															   0,
															   0,
															   Explode::SMALL_4
															 );
									
								iter->x = 600 <<12;
								iter->y = 96 << 12;
								break;
							}
						}
				
					}
				}
			
			}   // iter x < 
	
		}   // iter active
		
	}
	return false;
}



void SkulloContainer::KillAllEntities()
{
	std::vector<Skullo>::iterator iter;
	for( iter = Skullos.begin(); iter != Skullos.end(); ++iter )
	{
		if( iter->Active )
		{
			iter->Active = false;
			iter->x = 600 << 12;
			iter->y = 96 << 12;
		}
	}
	
}

//--------------------------------------
//	Non-Virtual Functions
//--------------------------------------
void SkulloContainer::Spawn( s32 _time, bool _flip )
{
	
	bool SlotFull = true;      		// value to check if all the slots are occupied
	
	std::vector<Skullo>::iterator iter;
	for( iter = Skullos.begin(); iter != Skullos.end(); ++iter )
	{
		if( !iter->Active )		// insert a bullet on a free slot
		{

			iter->Active = true;
			iter->Frame = 0;
			iter->Counter = 0;
			iter->Hp = 1;
			iter->LoadPath( 400, 96, -300, 96, _time, _flip );
			SlotFull = false;			// there's a free slot so we dont execute the code below
			break;
		
		}
	}
	
	// All the slots are full
	// Only push back a bullet if the slot is full and we have less than numbullets
	if( SlotFull && (Skullos.size() < MAX_SKULLOS) )
	{
		Skullo popcorn;
		popcorn.Active = true;
		popcorn.Frame = 0;
		popcorn.Counter = 0;
		popcorn.Hp = 1;
		popcorn.LoadPath( 400, 96, -300, 96, _time, _flip );
		Skullos.push_back(popcorn);
	}
	
}



